Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/mpp.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 5600)
@@ -1862,15 +2141,10 @@
    !>    structure.
    !>
-   !> @detail
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
    !
    !> @param[inout] td_mpp : mpp strcuture
    !> @param[in]    td_proc : file/processor structure
-   !
-   !> @todo check proc id exist
-   !-------------------------------------------------------------------
-   !> @code
+   !-------------------------------------------------------------------
    SUBROUTINE mpp__del_proc_str( td_mpp, td_proc )
       IMPLICIT NONE
@@ -1883,9 +2157,8 @@
          CALL mpp__del_proc( td_mpp, td_proc%i_pid )
       ELSE
-         CALL logger_error("DEL PROC: processor not defined")
+         CALL logger_error("MPP DEL PROC: processor not defined")
       ENDIF
 
    END SUBROUTINE mpp__del_proc_str
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -1895,13 +2168,9 @@
    !
    !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    id_procid : processor id
-   !> @todo
-   !> - voir si il ne faut pas redefinir (__copy) proc si il vient de mpp
-   !> exemple CALL  mpp_move_proc( td_mpp, td_mpp%t_proc )   
-   !-------------------------------------------------------------------
-   !> @code
+   !> @date Nov, 2013 - Initial version
+   !
+   !> @param[inout] td_mpp    mpp strcuture
+   !> @param[in]    id_procid processor id
+   !-------------------------------------------------------------------
    SUBROUTINE mpp__move_proc( td_mpp, td_proc )
       IMPLICIT NONE
@@ -1918,21 +2187,15 @@
 
    END SUBROUTINE mpp__move_proc
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine add a dimension structure in a mpp 
    !> structure.
    !> Do not overwrite, if dimension already in mpp structure.
-   !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_mpp : mpp structure
-   !> @param[in] td_dim : dimension structure
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   ! @code
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_mpp mpp structure
+   !> @param[in] td_dim    dimension structure
+   !-------------------------------------------------------------------
    SUBROUTINE mpp_add_dim(td_mpp, td_dim)
       IMPLICIT NONE
@@ -1942,47 +2205,52 @@
 
       ! local variable
-      INTEGER(i4) :: il_dimid
+      INTEGER(i4) :: il_ind
 
       ! loop indices
-      !----------------------------------------------------------------
-      IF( td_mpp%i_ndim <= 4 )THEN
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      IF( td_mpp%i_ndim <= ip_maxdim )THEN
 
          ! check if dimension already in mpp structure
-         il_dimid=dim_get_id(td_mpp%t_dim(:), td_dim%c_name, td_dim%c_sname)
-         IF( il_dimid /= 0 )THEN
-
-            CALL logger_error( &
-            &  " ADD DIM: dimension "//TRIM(td_dim%c_name)//&
-            &  ", short name "//TRIM(td_dim%c_sname)//&
-            &  ", already in mpp "//TRIM(td_mpp%c_name) )
+         il_ind=dim_get_index(td_mpp%t_dim(:), td_dim%c_name, td_dim%c_sname)
+         IF( il_ind /= 0 )THEN
+
+            IF( td_mpp%t_dim(il_ind)%l_use )THEN
+               CALL logger_error( &
+               &  "MPP ADD DIM: dimension "//TRIM(td_dim%c_name)//&
+               &  ", short name "//TRIM(td_dim%c_sname)//&
+               &  ", already used in mpp "//TRIM(td_mpp%c_name) )
+            ELSE
+               ! replace dimension
+               td_mpp%t_dim(il_ind)=dim_copy(td_dim)
+               td_mpp%t_dim(il_ind)%i_id=il_ind
+               td_mpp%t_dim(il_ind)%l_use=.TRUE.
+            ENDIF
 
          ELSE
 
-            CALL logger_debug( &
-            &  " ADD DIM: add dimension "//TRIM(td_dim%c_name)//&
-            &  ", short name "//TRIM(td_dim%c_sname)//&
-            &  ", in mpp "//TRIM(td_mpp%c_name) )
-
-            IF( td_mpp%i_ndim == 4 )THEN
+            IF( td_mpp%i_ndim == ip_maxdim )THEN
+               CALL logger_error( &
+               &  "MPP ADD DIM: can not add dimension "//TRIM(td_dim%c_name)//&
+               &  ", short name "//TRIM(td_dim%c_sname)//&
+               &  ", in mpp "//TRIM(td_mpp%c_name)//". Already "//&
+               &  TRIM(fct_str(ip_maxdim))//" dimensions." )
+            ELSE
                ! search empty dimension
-               il_dimid=dim_get_void_id(td_mpp%t_dim(:),TRIM(td_dim%c_name), &
-               &                                        TRIM(td_dim%c_sname))
-               ! replace empty dimension
-               td_mpp%t_dim(il_dimid)=td_dim
-               td_mpp%t_dim(il_dimid)%i_id=il_dimid
-               td_mpp%t_dim(il_dimid)%l_use=.TRUE.
-            ELSE
-               il_dimid=dim_get_void_id(td_mpp%t_dim(:),TRIM(td_dim%c_name), &
-               &                                        TRIM(td_dim%c_sname))
-               ! add new dimension
-               td_mpp%t_dim(il_dimid)=td_dim
-               td_mpp%t_dim(il_dimid)%i_id=td_mpp%i_ndim+1
-               td_mpp%t_dim(il_dimid)%l_use=.TRUE.
+               DO ji=1,ip_maxdim
+                  IF( td_mpp%t_dim(ji)%i_id == 0 )THEN
+                     il_ind=ji 
+                     EXIT
+                  ENDIF
+               ENDDO
+ 
+               ! add new dimension    
+               td_mpp%t_dim(il_ind)=dim_copy(td_dim)
                ! update number of attribute
                td_mpp%i_ndim=COUNT(td_mpp%t_dim(:)%l_use)
-            ENDIF
-
-            ! reorder dimension to ('x','y','z','t')
-            CALL dim_reorder(td_mpp%t_dim)
+
+               td_mpp%t_dim(il_ind)%l_use=.TRUE.
+               td_mpp%t_dim(il_ind)%i_id=td_mpp%i_ndim
+            ENDIF
 
          ENDIF
@@ -1990,25 +2258,19 @@
       ELSE
          CALL logger_error( &
-         &  " ADD DIM: too much dimension in mpp "//&
+         &  "MPP ADD DIM: too much dimension in mpp "//&
          &  TRIM(td_mpp%c_name)//" ("//TRIM(fct_str(td_mpp%i_ndim))//")")
       ENDIF
 
    END SUBROUTINE mpp_add_dim
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine delete a dimension structure in a mpp 
    !> structure.<br/>
-   !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_mpp : mpp structure
-   !> @param[in] td_dim : dimension structure
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   ! @code
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_mpp mpp structure
+   !> @param[in] td_dim    dimension structure
+   !-------------------------------------------------------------------
    SUBROUTINE mpp_del_dim(td_mpp, td_dim)
       IMPLICIT NONE
@@ -2019,97 +2281,68 @@
       ! local variable
       INTEGER(i4) :: il_status
-      INTEGER(i4) :: il_dimid
+      INTEGER(i4) :: il_ind
       TYPE(TDIM), DIMENSION(:), ALLOCATABLE  :: tl_dim
 
       ! loop indices
-      !----------------------------------------------------------------
-      IF( td_mpp%i_ndim <= 4 )THEN
-
-         ! check if dimension already in mpp structure
-         il_dimid=dim_get_id(td_mpp%t_dim(:), td_dim%c_name, td_dim%c_sname)
-         IF( il_dimid == 0 )THEN
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      ! check if dimension already in mpp structure
+      il_ind=dim_get_index(td_mpp%t_dim(:), td_dim%c_name, td_dim%c_sname)
+      IF( il_ind == 0 )THEN
+
+         CALL logger_error( &
+         &  "MPP DEL DIM: no dimension "//TRIM(td_dim%c_name)//&
+         &  ", short name "//TRIM(td_dim%c_sname)//&
+         &  ", in mpp "//TRIM(td_mpp%c_name) )
+
+      ELSE
+
+         ALLOCATE( tl_dim(td_mpp%i_ndim-1), stat=il_status )
+         IF(il_status /= 0 )THEN
 
             CALL logger_error( &
-            &  " DEL DIM: no dimension "//TRIM(td_dim%c_name)//&
-            &  ", short name "//TRIM(td_dim%c_sname)//&
-            &  ", in mpp "//TRIM(td_mpp%c_name) )
+            &  "MPP DEL DIM: not enough space to put dimensions from "//&
+            &  TRIM(td_mpp%c_name)//" in temporary dimension structure")
 
          ELSE
 
-            CALL logger_debug( &
-            &  " DEL DIM: delete dimension "//TRIM(td_dim%c_name)//&
-            &  ", short name "//TRIM(td_dim%c_sname)//&
-            &  ", in mpp "//TRIM(td_mpp%c_name) )
-
-            IF( td_mpp%i_ndim == 4 )THEN
-               ALLOCATE( tl_dim(1), stat=il_status )
-               IF(il_status /= 0 )THEN
-                  CALL logger_error( &
-                  &  " DEL DIM: not enough space to put dimensions from "//&
-                  &  TRIM(td_mpp%c_name)//" in temporary dimension structure")
-               ELSE
-                  ! replace dimension by empty one
-                  td_mpp%t_dim(il_dimid)=tl_dim(1)
-               ENDIF
-               DEALLOCATE(tl_dim)
-            ELSE
-               ! 
-               ALLOCATE( tl_dim(td_mpp%i_ndim), stat=il_status )
-               IF(il_status /= 0 )THEN
-
-                  CALL logger_error( &
-                  &  " DEL DIM: not enough space to put dimensions from "//&
-                  &  TRIM(td_mpp%c_name)//" in temporary dimension structure")
-
-               ELSE
-
-                  ! save temporary dimension's mpp structure
-                  tl_dim( 1 : il_dimid-1 ) = td_mpp%t_dim( 1 : il_dimid-1 )
-                  tl_dim( il_dimid : td_mpp%i_ndim-1 ) = &
-                  &           td_mpp%t_dim( il_dimid+1 : td_mpp%i_ndim )
-
-                  ! copy dimension in file, except one
-                  td_mpp%t_dim(1:td_mpp%i_ndim)=tl_dim(:)
-
-                  ! update number of dimension
-                  td_mpp%i_ndim=td_mpp%i_ndim-1
-
-               ENDIF
-            ENDIF
-
-            ! reorder dimension to ('x','y','z','t')
-            CALL dim_reorder(td_mpp%t_dim)
-
-            !IF( ASSOCIATED(td_mpp%t_proc) )THEN
-            !   ! del dimension of processor
-            !   DO ji=1,td_mpp%i_nproc
-            !      CALL file_del_dim(td_mpp%t_proc(ji), td_dim)
-            !   ENDDO
-            !ENDIF
+            ! save temporary dimension's mpp structure
+            tl_dim( 1 : il_ind-1 ) = dim_copy(td_mpp%t_dim( 1 : il_ind-1 ))
+            tl_dim( il_ind : td_mpp%i_ndim-1 ) = &
+            &           dim_copy(td_mpp%t_dim( il_ind+1 : td_mpp%i_ndim ))
+
+            ! remove dimension from file
+            CALL dim_clean(td_mpp%t_dim(:))
+            ! copy dimension in file, except one
+            td_mpp%t_dim(1:td_mpp%i_ndim)=dim_copy(tl_dim(:))
+
+            ! update number of dimension
+            td_mpp%i_ndim=td_mpp%i_ndim-1
+
+            ! update dimension id
+            DO ji=1,td_mpp%i_ndim
+               td_mpp%t_dim(ji)%i_id=ji
+            ENDDO
+
+            ! clean
+            CALL dim_clean(tl_dim(:))
+            DEALLOCATE(tl_dim)
 
          ENDIF
-      ELSE
-         CALL logger_error( &
-         &  " DEL DIM: too much dimension in mpp "//&
-         &  TRIM(td_mpp%c_name)//" ("//TRIM(fct_str(td_mpp%i_ndim))//")")
+
       ENDIF
 
    END SUBROUTINE mpp_del_dim
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine move a dimension structure 
    !> in mpp structure.
    !> @warning dimension order may have changed
-   !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_mpp : mpp structure
-   !> @param[in] td_dim : dimension structure
-   !> @todo
-   !-------------------------------------------------------------------
-   ! @code
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_mpp mpp structure
+   !> @param[in] td_dim    dimension structure
+   !-------------------------------------------------------------------
    SUBROUTINE mpp_move_dim(td_mpp, td_dim)
       IMPLICIT NONE
@@ -2119,35 +2352,39 @@
 
       ! local variable
+      INTEGER(i4) :: il_ind
       INTEGER(i4) :: il_dimid
-
-      !----------------------------------------------------------------
-
-      il_dimid=dim_get_id(td_mpp%t_dim(:), TRIM(td_dim%c_name), &
-      &                                    TRIM(td_dim%c_sname))
-      IF( il_dimid /= 0 )THEN
-         ! remove dimension with same name
-         CALL mpp_del_dim(td_mpp, td_dim)
-      ENDIF
-
-      ! add new dimension
-      CALL mpp_add_dim(td_mpp, td_dim)
-
+      !----------------------------------------------------------------
+      IF( td_mpp%i_ndim <= ip_maxdim )THEN
+
+         ! check if dimension already in mpp structure
+         il_ind=dim_get_index(td_mpp%t_dim(:), td_dim%c_name, td_dim%c_sname)
+         IF( il_ind /= 0 )THEN
+
+            il_dimid=td_mpp%t_dim(il_ind)%i_id
+            ! replace dimension
+            td_mpp%t_dim(il_ind)=dim_copy(td_dim)
+            td_mpp%t_dim(il_ind)%i_id=il_dimid
+            td_mpp%t_dim(il_ind)%l_use=.TRUE.
+
+         ELSE
+            CALL mpp_add_dim(td_mpp, td_dim)
+         ENDIF
+
+      ELSE
+         CALL logger_error( &
+         &  "MPP MOVE DIM: too much dimension in mpp "//&
+         &  TRIM(td_mpp%c_name)//" ("//TRIM(fct_str(td_mpp%i_ndim))//")")
+      ENDIF
    END SUBROUTINE mpp_move_dim
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief
    !>    This subroutine add global attribute to mpp structure.
    !>
-   !> @detail
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    td_att : attribute strcuture
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !>
+   !> @param[inout] td_mpp mpp strcuture
+   !> @param[in]    td_att attribute strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE mpp_add_att( td_mpp, td_att )
       IMPLICIT NONE
@@ -2176,11 +2413,12 @@
             il_attid=0
             IF( ASSOCIATED(td_mpp%t_proc(1)%t_att) )THEN
-               il_attid=att_get_id( td_mpp%t_proc(1)%t_att(:), &
+               il_attid=att_get_index( td_mpp%t_proc(1)%t_att(:), &
                &                    td_att%c_name )
             ENDIF
             IF( il_attid /= 0 )THEN
 
-               CALL logger_error( " MPP ADD ATT: attribute "//TRIM(td_att%c_name)//&
-               &  ", already in mpp "//TRIM(td_mpp%c_name) )
+               CALL logger_error( " MPP ADD ATT: attribute "//&
+               &                 TRIM(td_att%c_name)//&
+               &                 ", already in mpp "//TRIM(td_mpp%c_name) )
 
                DO ji=1,td_mpp%t_proc(1)%i_natt
@@ -2192,5 +2430,5 @@
             
                CALL logger_info( &
-               &  " MPP ADD VAR: add attribute "//TRIM(td_att%c_name)//&
+               &  " MPP ADD ATT: add attribute "//TRIM(td_att%c_name)//&
                &  ", in mpp "//TRIM(td_mpp%c_name) )
 
@@ -2207,5 +2445,4 @@
 
    END SUBROUTINE mpp_add_att
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -2213,19 +2450,10 @@
    !> structure.
    !>
-   !> @detail
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    td_att : attribute strcuture
-   !
-   !> @todo 
-   !> - check proc id exist
-   !> - check proc dimension
-   !> - check proc file name
-   !> - check proc type
-   !-------------------------------------------------------------------
-   !> @code
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !>
+   !> @param[inout] td_mpp mpp strcuture
+   !> @param[in]    td_att attribute strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE mpp__del_att_str( td_mpp, td_att )
       IMPLICIT NONE
@@ -2244,5 +2472,5 @@
       IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
 
-         CALL logger_error( " DEL VAR: domain decomposition not define "//&
+         CALL logger_warn( "MPP DEL VAR: domain decomposition not define "//&
          &               " in mpp strcuture "//TRIM(td_mpp%c_name))
 
@@ -2252,20 +2480,24 @@
          il_attid=0
          IF( ASSOCIATED(td_mpp%t_proc(1)%t_att) )THEN
-            il_attid=att_get_id( td_mpp%t_proc(1)%t_att(:), &
+            il_attid=att_get_index( td_mpp%t_proc(1)%t_att(:), &
             &                    td_att%c_name )
          ENDIF
          IF( il_attid == 0 )THEN
-            CALL logger_error( &
-            &  " DEL VAR: no attribute "//TRIM(td_att%c_name)//&
+            CALL logger_warn( &
+            &  "MPP DEL VAR: no attribute "//TRIM(td_att%c_name)//&
             &  ", in mpp structure "//TRIM(td_mpp%c_name) )
 
-            DO ji=1,td_mpp%t_proc(1)%i_natt
-               CALL logger_debug( " DEL ATT: in mpp structure : &
-               &  attribute : "//TRIM(td_mpp%t_proc(1)%t_var(ji)%c_name) )
-            ENDDO
+            IF( ASSOCIATED(td_mpp%t_proc(1)%t_var) )THEN
+               DO ji=1,td_mpp%t_proc(1)%i_natt
+                  CALL logger_debug( "MPP DEL ATT: in mpp structure : &
+                  &  attribute : "//TRIM(td_mpp%t_proc(1)%t_var(ji)%c_name) )
+               ENDDO
+            ENDIF
 
          ELSE
 
             cl_name=TRIM(td_att%c_name)
+            CALL logger_debug( "MPP DEL ATT: delete in mpp structure : &
+            &  attribute : "//TRIM(cl_name) )
             DO ji=1,td_mpp%i_nproc
                CALL file_del_att(td_mpp%t_proc(ji), TRIM(cl_name)) 
@@ -2276,5 +2508,4 @@
       ENDIF
    END SUBROUTINE mpp__del_att_str
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -2284,16 +2515,9 @@
    !
    !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    cd_name: attribute name
-   !
-   !> @todo 
-   !> - check proc id exist
-   !> - check proc dimension
-   !> - check proc file name
-   !> - check proc type
-   !-------------------------------------------------------------------
-   !> @code
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[inout] td_mpp    mpp strcuture
+   !> @param[in]    cd_name   attribute name
+   !-------------------------------------------------------------------
    SUBROUTINE mpp__del_att_name( td_mpp, cd_name )
       IMPLICIT NONE
@@ -2308,5 +2532,5 @@
       IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
 
-         CALL logger_error( " DEL ATT: domain decomposition not define "//&
+         CALL logger_warn( "MPP DEL ATT: domain decomposition not define "//&
          &               " in mpp strcuture "//TRIM(td_mpp%c_name))
 
@@ -2314,5 +2538,5 @@
 
          IF( td_mpp%t_proc(1)%i_natt == 0 )THEN
-            CALL logger_debug( " DEL ATT NAME: no attribute associated to mpp &
+            CALL logger_debug( "MPP DEL ATT NAME: no attribute associated to mpp &
             &                 structure "//TRIM(td_mpp%c_name) )
          ELSE
@@ -2328,5 +2552,5 @@
 
                CALL logger_warn( &
-               &  " DEL ATT : there is no attribute with "//&
+               &  "MPP DEL ATT : there is no attribute with "//&
                &  "name "//TRIM(cd_name)//" in mpp structure "//&
                &  TRIM(td_mpp%c_name))
@@ -2341,19 +2565,14 @@
       ENDIF
    END SUBROUTINE mpp__del_att_name
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !>    This subroutine overwrite attribute in mpp structure.
    !>
-   !> @detail
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    td_att : attribute structure
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[inout] td_mpp mpp strcuture
+   !> @param[in]    td_att attribute structure
+   !-------------------------------------------------------------------
    SUBROUTINE mpp_move_att( td_mpp, td_att )
       IMPLICIT NONE
@@ -2363,8 +2582,8 @@
 
       !local variable
-      TYPE(TATT) :: tl_att
+      TYPE(TATT)  :: tl_att
       !----------------------------------------------------------------
       ! copy variable
-      tl_att=td_att
+      tl_att=att_copy(td_att)
 
       ! remove processor
@@ -2374,6 +2593,8 @@
       CALL mpp_add_att(td_mpp, tl_att)
 
+      ! clean
+      CALL att_clean(tl_att)
+
    END SUBROUTINE mpp_move_att
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -2388,9 +2609,8 @@
    !
    !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[inout] td_mpp mpp strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE mpp__compute( td_mpp )
       IMPLICIT NONE
@@ -2410,5 +2630,5 @@
       CHARACTER(LEN=lc)                        :: cl_file
       TYPE(TFILE)                              :: tl_proc
-      TYPE(TATT)                               ::tl_att
+      TYPE(TATT)                               :: tl_att
 
       ! loop indices
@@ -2421,5 +2641,5 @@
       td_mpp%i_nproc=0
 
-      CALL logger_trace( "COMPUTE: compute domain decomposition with "//&
+      CALL logger_trace( "MPP COMPUTE: compute domain decomposition with "//&
       &               TRIM(fct_str(td_mpp%i_niproc))//" x "//&
       &               TRIM(fct_str(td_mpp%i_njproc))//" processors")
@@ -2498,5 +2718,4 @@
             &                (/tl_proc%i_lci, tl_proc%i_lcj/) )
             CALL file_add_att(tl_proc, tl_att)
-
 
             ! compute first and last indoor indices
@@ -2544,4 +2763,8 @@
             CALL mpp__add_proc(td_mpp, tl_proc)
 
+            ! clean
+            CALL att_clean(tl_att)
+            CALL file_clean(tl_proc)
+
          ENDDO
       ENDDO
@@ -2551,16 +2774,14 @@
 
    END SUBROUTINE mpp__compute
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
    !>  This subroutine remove land processor from domain decomposition.
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in] id_mask : sub domain mask (sea=1, land=0)
-   !-------------------------------------------------------------------
-   !> @code
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !>
+   !> @param[inout] td_mpp mpp strcuture
+   !> @param[in] id_mask   sub domain mask (sea=1, land=0)
+   !-------------------------------------------------------------------
    SUBROUTINE mpp__del_land( td_mpp, id_mask )
       IMPLICIT NONE
@@ -2583,9 +2804,8 @@
          ENDDO
       ELSE
-         CALL logger_error("DEL LAND: domain decomposition not define.")
+         CALL logger_error("MPP DEL LAND: domain decomposition not define.")
       ENDIF
 
    END SUBROUTINE mpp__del_land
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
@@ -2596,9 +2816,9 @@
    !
    !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[inout] td_mpp mpp strcuture
+   !> @param[in] id_mask   sub domain mask (sea=1, land=0) 
+   !-------------------------------------------------------------------
    SUBROUTINE mpp__optimiz( td_mpp, id_mask )
       IMPLICIT NONE
@@ -2617,6 +2837,6 @@
       !----------------------------------------------------------------
 
-      CALL logger_trace("OPTIMIZ: look for best domain decomposition")
-      tl_mpp=td_mpp
+      CALL logger_trace("MPP OPTIMIZ: look for best domain decomposition")
+      tl_mpp=mpp_copy(td_mpp)
 
       ! save maximum number of processor to be used
@@ -2629,4 +2849,5 @@
             ! clean mpp processor
             IF( ASSOCIATED(tl_mpp%t_proc) )THEN
+               CALL file_clean(tl_mpp%t_proc(:))
                DEALLOCATE(tl_mpp%t_proc)
             ENDIF
@@ -2641,5 +2862,5 @@
             CALL mpp__del_land( tl_mpp, id_mask )
 
-            CALL logger_info("OPTIMIZ: number of processor "//&
+            CALL logger_info("MPP OPTIMIZ: number of processor "//&
             &  TRIM(fct_str(tl_mpp%i_nproc)) )
             IF( tl_mpp%i_nproc > td_mpp%i_nproc .AND. &
@@ -2650,18 +2871,22 @@
                CALL mpp_clean(td_mpp)
 
-               ! save processor table
+               ! save processor array
                ALLOCATE( tl_proc(tl_mpp%i_nproc) )
-               tl_proc(:)=tl_mpp%t_proc(:)
-
-               ! remove pointer on processor table
+               tl_proc(:)=file_copy(tl_mpp%t_proc(:))
+
+               ! remove pointer on processor array
+               CALL file_clean(tl_mpp%t_proc(:))
                DEALLOCATE(tl_mpp%t_proc)
  
-               ! save data except processor table
-               td_mpp=tl_mpp
-               ! save processor table
+               ! save data except processor array
+               td_mpp=mpp_copy(tl_mpp)
+
+               ! save processor array
                ALLOCATE( td_mpp%t_proc(td_mpp%i_nproc) )
-               td_mpp%t_proc(:)=tl_proc(:)
-
-               DEALLOCATE( tl_proc )
+               td_mpp%t_proc(:)=file_copy(tl_proc(:))
+
+               ! clean
+               CALL file_clean( tl_proc(:) )
+               DEALLOCATE(tl_proc)
 
             ENDIF
@@ -2670,18 +2895,19 @@
       ENDDO
 
+      ! clean
+      CALL mpp_clean(tl_mpp)
+
    END SUBROUTINE mpp__optimiz
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !>    This function check if processor is a land processor.
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[in] td_mpp : mpp strcuture
-   !> @param[in] id_proc : processor id
-   !> @param[in] id_mask : sub domain mask (sea=1, land=0)
-   !-------------------------------------------------------------------
-   !> @code
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !>
+   !> @param[in] td_mpp    mpp strcuture
+   !> @param[in] id_proc   processor id
+   !> @param[in] id_mask   sub domain mask (sea=1, land=0)
+   !-------------------------------------------------------------------
    LOGICAL FUNCTION mpp__land_proc( td_mpp , id_proc, id_mask )
       IMPLICIT NONE
@@ -2695,5 +2921,5 @@
       !----------------------------------------------------------------
 
-      CALL logger_trace("LAND PROC: check processor "//TRIM(fct_str(id_proc))//&
+      CALL logger_trace("MPP LAND PROC: check processor "//TRIM(fct_str(id_proc))//&
       &  " of mpp "//TRIM(td_mpp%c_name) )
       mpp__land_proc=.FALSE.
@@ -2703,5 +2929,11 @@
          IF( il_shape(1) /= td_mpp%t_dim(1)%i_len .OR. &
          &   il_shape(2) /= td_mpp%t_dim(2)%i_len )THEN
-             CALL logger_error("LAND PROC: mask and domain size differ")
+             CALL logger_debug("MPP LAND PROC: mask size ("//&
+             &                  TRIM(fct_str(il_shape(1)))//","//&
+             &                  TRIM(fct_str(il_shape(2)))//")")
+             CALL logger_debug("MPP LAND PROC: domain size ("//&
+             &                  TRIM(fct_str(td_mpp%t_dim(1)%i_len))//","//&
+             &                  TRIM(fct_str(td_mpp%t_dim(2)%i_len))//")")
+             CALL logger_error("MPP LAND PROC: mask and domain size differ")
          ELSE
             IF( ALL(id_mask( td_mpp%t_proc(id_proc)%i_impp +            &
@@ -2715,5 +2947,5 @@
             &      /= 1 ) )THEN
                ! land domain
-               CALL logger_info(" LAND PROC: processor "//TRIM(fct_str(id_proc))//&
+               CALL logger_info("MPP LAND PROC: processor "//TRIM(fct_str(id_proc))//&
                &             " is land processor")
                mpp__land_proc=.TRUE.
@@ -2722,20 +2954,18 @@
 
       ELSE
-         CALL logger_error("LAND PROC: domain decomposition not define.")
+         CALL logger_error("MPP LAND PROC: domain decomposition not define.")
       ENDIF
 
    END FUNCTION mpp__land_proc
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
    !>  This subroutine clean mpp strcuture.
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE mpp_clean( td_mpp )
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !>
+   !> @param[inout] td_mpp mpp strcuture
+   !-------------------------------------------------------------------
+   SUBROUTINE mpp__clean_unit( td_mpp )
       IMPLICIT NONE
       ! Argument
